Annotate every indirect sugar-method
[dbsrgits/DBIx-Class.git] / lib / DBIx / Class / _Util.pm
CommitLineData
b1dbf716 1package # hide from PAUSE
2 DBIx::Class::_Util;
3
399b9455 4use DBIx::Class::StartupCheck; # load es early as we can, usually a noop
5
b1dbf716 6use warnings;
7use strict;
8
953f8eb0 9# For the love of everything that is crab-like: DO NOT reach into this
10# The entire thing is really fragile and should not be screwed with
11# unless absolutely and unavoidably necessary
12our $__describe_class_query_cache;
296248c3 13
37873f78 14BEGIN {
15 package # hide from pause
16 DBIx::Class::_ENV_;
17
18 use Config;
19
20 use constant {
3605497b 21 PERL_VERSION => "$]",
22 OS_NAME => "$^O",
23 };
24
25 use constant {
37873f78 26
27 # but of course
3605497b 28 BROKEN_FORK => (OS_NAME eq 'MSWin32') ? 1 : 0,
37873f78 29
3605497b 30 BROKEN_GOTO => ( PERL_VERSION < 5.008003 ) ? 1 : 0,
8d73fcd4 31
7bba735d 32 # perl -MScalar::Util=weaken -e 'weaken( $hash{key} = \"value" )'
3605497b 33 BROKEN_WEAK_SCALARREF_VALUES => ( PERL_VERSION < 5.008003 ) ? 1 : 0,
7bba735d 34
37873f78 35 HAS_ITHREADS => $Config{useithreads} ? 1 : 0,
36
5f0174dc 37 TAINT_MODE => 0 + ${^TAINT}, # tri-state: 0, 1, -1
38
3605497b 39 UNSTABLE_DOLLARAT => ( PERL_VERSION < 5.013002 ) ? 1 : 0,
bbf6a9a5 40
db83437e 41 ( map
42 #
43 # the "DBIC_" prefix below is crucial - this is what makes CI pick up
44 # all envvars without further adjusting its scripts
45 # DO NOT CHANGE to the more logical { $_ => !!( $ENV{"DBIC_$_"} ) }
46 #
47 { substr($_, 5) => !!( $ENV{$_} ) }
48 qw(
49 DBIC_SHUFFLE_UNORDERED_RESULTSETS
50 DBIC_ASSERT_NO_INTERNAL_WANTARRAY
51 DBIC_ASSERT_NO_INTERNAL_INDIRECT_CALLS
534aff61 52 DBIC_ASSERT_NO_ERRONEOUS_METAINSTANCE_USE
db83437e 53 DBIC_STRESSTEST_UTF8_UPGRADE_GENERATED_COLLAPSER_SOURCE
54 DBIC_STRESSTEST_COLUMN_INFO_UNAWARE_STORAGE
55 )
56 ),
f45dc928 57
37873f78 58 IV_SIZE => $Config{ivsize},
59 };
60
3605497b 61 if ( PERL_VERSION < 5.009_005) {
37873f78 62 require MRO::Compat;
63 constant->import( OLD_MRO => 1 );
296248c3 64
65 #
66 # Yes, I know this is a rather PHP-ish name, but please first read
67 # https://metacpan.org/source/BOBTFISH/MRO-Compat-0.12/lib/MRO/Compat.pm#L363-368
68 #
69 # Even if we are using Class::C3::XS it still won't work, as doing
70 # defined( *{ "SubClass::"->{$_} }{CODE} )
71 # will set pkg_gen to the same value for SubClass and *ALL PARENTS*
72 #
73 *DBIx::Class::_Util::get_real_pkg_gen = sub ($) {
74 require Digest::MD5;
75 require Math::BigInt;
76
953f8eb0 77 my $cur_class;
78 no strict 'refs';
79
296248c3 80 # the non-assign-unless-there-is-a-hash is deliberate
953f8eb0 81 ( $__describe_class_query_cache->{'!internal!'} || {} )->{$_[0]}{gen} ||= (
296248c3 82 Math::BigInt->new( '0x' . ( Digest::MD5::md5_hex( join "\0", map {
83
953f8eb0 84 ( $__describe_class_query_cache->{'!internal!'} || {} )->{$_}{methlist} ||= (
85
86 $cur_class = $_
296248c3 87
953f8eb0 88 and
1c179556 89
90 # RV to be hashed up and turned into a number
91 join "\0", (
953f8eb0 92 $cur_class,
296248c3 93 map
1c179556 94 {(
95 # stringification should be sufficient, ignore names/refaddr entirely
96 $_,
92705f7f 97 do {
98 my @attrs;
99 local $@;
100 local $SIG{__DIE__} if $SIG{__DIE__};
101 # attributes::get may throw on blessed-false crefs :/
102 eval { @attrs = attributes::get( $_ ); 1 }
103 or warn "Unable to determine attributes of coderef $_ due to the following error: $@";
104 @attrs;
105 },
1c179556 106 )}
296248c3 107 map
1c179556 108 {(
109 # skip dummy C::C3 helper crefs
953f8eb0 110 ! ( ( $Class::C3::MRO{$cur_class} || {} )->{methods}{$_} )
1c179556 111 and
296248c3 112 (
953f8eb0 113 ref(\ "${cur_class}::"->{$_} ) ne 'GLOB'
296248c3 114 or
953f8eb0 115 defined( *{ "${cur_class}::"->{$_} }{CODE} )
296248c3 116 )
1c179556 117 )
953f8eb0 118 ? ( \&{"${cur_class}::$_"} )
296248c3 119 : ()
120 }
953f8eb0 121 keys %{ "${cur_class}::" }
122 )
123 )
d01688cc 124 } (
125
126 @{
953f8eb0 127 ( $__describe_class_query_cache->{'!internal!'} || {} )->{$_[0]}{linear_isa}
d01688cc 128 ||=
129 mro::get_linear_isa($_[0])
130 },
131
132 ((
953f8eb0 133 ( $__describe_class_query_cache->{'!internal!'} || {} )->{$_[0]}{is_universal}
d01688cc 134 ||=
135 mro::is_universal($_[0])
136 ) ? () : @{
953f8eb0 137 ( $__describe_class_query_cache->{'!internal!'} || {} )->{UNIVERSAL}{linear_isa}
d01688cc 138 ||=
139 mro::get_linear_isa("UNIVERSAL")
140 } ),
141
142 ) ) ) )
296248c3 143 );
144 };
37873f78 145 }
146 else {
147 require mro;
148 constant->import( OLD_MRO => 0 );
296248c3 149 *DBIx::Class::_Util::get_real_pkg_gen = \&mro::get_pkg_gen;
37873f78 150 }
4b1b44c1 151
152 # Both of these are no longer used for anything. However bring
153 # them back after they were purged in 08a8d8f1, as there appear
154 # to be outfits with *COPY PASTED* pieces of lib/DBIx/Class/Storage/*
155 # in their production codebases. There is no point in breaking these
156 # if whatever they used actually continues to work
4b1b44c1 157 my $sigh = sub {
c40b5744 158 DBIx::Class::_Util::emit_loud_diag(
159 skip_frames => 1,
160 msg => "The @{[ (caller(1))[3] ]} constant is no more - adjust your code"
161 );
4b1b44c1 162
163 0;
164 };
165 sub DBICTEST () { &$sigh }
166 sub PEEPEENESS () { &$sigh }
37873f78 167}
168
3605497b 169use constant SPURIOUS_VERSION_CHECK_WARNINGS => ( DBIx::Class::_ENV_::PERL_VERSION < 5.010 ? 1 : 0);
170
841efcb3 171# FIXME - this is not supposed to be here
172# Carp::Skip to the rescue soon
173use DBIx::Class::Carp '^DBIx::Class|^DBICTest';
174
d7d45bdc 175use B ();
841efcb3 176use Carp 'croak';
d7d45bdc 177use Storable 'nfreeze';
3d56e026 178use Scalar::Util qw(weaken blessed reftype refaddr);
514b84f6 179use Sub::Name ();
296248c3 180use attributes ();
7f9a3f70 181
6de81918 182# Usually versions are not specified anywhere aside the Makefile.PL
183# (writing them out in-code is extremely obnoxious)
184# However without a recent enough Moo the quote_sub override fails
185# in very puzzling and hard to detect ways: so add a version check
186# just this once
187use Sub::Quote qw(qsub);
188BEGIN { Sub::Quote->VERSION('2.002002') }
189
1c30a2e4 190# Already correctly prototyped: perlbrew exec perl -MStorable -e 'warn prototype \&Storable::dclone'
191BEGIN { *deep_clone = \&Storable::dclone }
192
b1dbf716 193use base 'Exporter';
3705e3b2 194our @EXPORT_OK = qw(
d634850b 195 sigwarn_silencer modver_gt_or_eq modver_gt_or_eq_and_lt
77c3a5dc 196 fail_on_internal_wantarray fail_on_internal_call
86a432d4 197 refdesc refcount hrefaddr set_subname get_subname describe_class_methods
c40b5744 198 scope_guard detected_reinvoked_destructor emit_loud_diag
293cb2f1 199 true false
10be570e 200 is_exception dbic_internal_try visit_namespaces
201 quote_sub qsub perlstring serialize deep_clone dump_value uniq
439a7283 202 parent_dir mkdir_p
facd0e8e 203 UNRESOLVABLE_CONDITION
3705e3b2 204);
052a832c 205
facd0e8e 206use constant UNRESOLVABLE_CONDITION => \ '1 = 0';
207
e85eb407 208# Override forcing no_defer, and adding naming consistency checks
dc715747 209our %refs_closed_over_by_quote_sub_installed_crefs;
e85eb407 210sub quote_sub {
9642350a 211 Carp::confess( "Anonymous quoting not supported by the DBIC quote_sub override - supply a sub name" ) if
e85eb407 212 @_ < 2
213 or
214 ! defined $_[1]
215 or
216 length ref $_[1]
217 ;
218
9642350a 219 Carp::confess( "The DBIC quote_sub override expects sub name '$_[0]' to be fully qualified" )
220 unless (my $stash) = $_[0] =~ /^(.+)::/;
221
222 Carp::confess(
223 "The DBIC sub_quote override does not support 'no_install'"
224 ) if (
225 $_[3]
226 and
227 $_[3]->{no_install}
228 );
e85eb407 229
9642350a 230 Carp::confess(
231 'The DBIC quote_sub override expects the namespace-part of sub name '
232 . "'$_[0]' to match the supplied package argument '$_[3]->{package}'"
233 ) if (
e85eb407 234 $_[3]
235 and
236 defined $_[3]->{package}
237 and
9642350a 238 $stash ne $_[3]->{package}
239 );
e85eb407 240
241 my @caller = caller(0);
242 my $sq_opts = {
243 package => $caller[0],
244 hints => $caller[8],
245 warning_bits => $caller[9],
246 hintshash => $caller[10],
247 %{ $_[3] || {} },
248
249 # explicitly forced for everything
250 no_defer => 1,
251 };
252
dc715747 253 weaken (
254 # just use a growing counter, no need to perform neither compaction
255 # nor any special ithread-level handling
256 $refs_closed_over_by_quote_sub_installed_crefs
257 { scalar keys %refs_closed_over_by_quote_sub_installed_crefs }
258 = $_
259 ) for grep {
260 length ref $_
261 and
262 (
263 ! DBIx::Class::_ENV_::BROKEN_WEAK_SCALARREF_VALUES
264 or
265 ref $_ ne 'SCALAR'
266 )
267 } values %{ $_[2] || {} };
268
9642350a 269 Sub::Quote::quote_sub( $_[0], $_[1], $_[2]||{}, $sq_opts );
e85eb407 270}
271
bf302897 272sub sigwarn_silencer ($) {
052a832c 273 my $pattern = shift;
274
275 croak "Expecting a regexp" if ref $pattern ne 'Regexp';
276
277 my $orig_sig_warn = $SIG{__WARN__} || sub { CORE::warn(@_) };
278
279 return sub { &$orig_sig_warn unless $_[0] =~ $pattern };
280}
b1dbf716 281
01b25f12 282sub perlstring ($) { q{"}. quotemeta( shift ). q{"} };
283
3d56e026 284sub hrefaddr ($) { sprintf '0x%x', &refaddr||0 }
8433421f 285
286sub refdesc ($) {
287 croak "Expecting a reference" if ! length ref $_[0];
288
289 # be careful not to trigger stringification,
290 # reuse @_ as a scratch-pad
291 sprintf '%s%s(0x%x)',
292 ( defined( $_[1] = blessed $_[0]) ? "$_[1]=" : '' ),
293 reftype $_[0],
3d56e026 294 refaddr($_[0]),
8433421f 295 ;
296}
bf302897 297
298sub refcount ($) {
dac7972a 299 croak "Expecting a reference" if ! length ref $_[0];
300
dac7972a 301 # No tempvars - must operate on $_[0], otherwise the pad
302 # will count as an extra ref
303 B::svref_2object($_[0])->REFCNT;
304}
305
10be570e 306sub visit_namespaces {
307 my $args = { (ref $_[0]) ? %{$_[0]} : @_ };
308
309 my $visited_count = 1;
310
311 # A package and a namespace are subtly different things
312 $args->{package} ||= 'main';
313 $args->{package} = 'main' if $args->{package} =~ /^ :: (?: main )? $/x;
314 $args->{package} =~ s/^:://;
315
316 if ( $args->{action}->($args->{package}) ) {
317 my $ns =
318 ( ($args->{package} eq 'main') ? '' : $args->{package} )
319 .
320 '::'
321 ;
322
323 $visited_count += visit_namespaces( %$args, package => $_ ) for
324 grep
325 # this happens sometimes on %:: traversal
326 { $_ ne '::main' }
327 map
328 { $_ =~ /^(.+?)::$/ ? "$ns$1" : () }
329 do { no strict 'refs'; keys %$ns }
330 ;
331 }
332
333 $visited_count;
334}
335
86a432d4 336# FIXME In another life switch these to a polyfill like the ones in namespace::clean
337sub get_subname ($) {
338 my $gv = B::svref_2object( $_[0] )->GV;
339 wantarray
340 ? ( $gv->STASH->NAME, $gv->NAME )
341 : ( join '::', $gv->STASH->NAME, $gv->NAME )
342 ;
343}
514b84f6 344sub set_subname ($$) {
345
346 # fully qualify name
347 splice @_, 0, 1, caller(0) . "::$_[0]"
348 if $_[0] !~ /::|'/;
349
350 &Sub::Name::subname;
351}
352
b34d9331 353sub serialize ($) {
b34d9331 354 local $Storable::canonical = 1;
d7d45bdc 355 nfreeze($_[0]);
b34d9331 356}
357
10be570e 358sub uniq {
359 my( %seen, $seen_undef, $numeric_preserving_copy );
360 grep { not (
361 defined $_
362 ? $seen{ $numeric_preserving_copy = $_ }++
363 : $seen_undef++
364 ) } @_;
365}
366
2d5ac3cf 367my $dd_obj;
8fc4291e 368sub dump_value ($) {
369 local $Data::Dumper::Indent = 1
370 unless defined $Data::Dumper::Indent;
371
2d5ac3cf 372 my $dump_str = (
8fc4291e 373 $dd_obj
374 ||=
375 do {
376 require Data::Dumper;
377 my $d = Data::Dumper->new([])
378 ->Purity(0)
379 ->Pad('')
380 ->Useqq(1)
381 ->Terse(1)
382 ->Freezer('')
383 ->Quotekeys(0)
384 ->Bless('bless')
385 ->Pair(' => ')
386 ->Sortkeys(1)
387 ->Deparse(1)
388 ;
389
390 $d->Sparseseen(1) if modver_gt_or_eq (
391 'Data::Dumper', '2.136'
392 );
393
394 $d;
395 }
396 )->Values([$_[0]])->Dump;
397
398 $dd_obj->Reset->Values([]);
399
400 $dump_str;
401}
402
c40b5744 403my $seen_loud_screams;
404sub emit_loud_diag {
405 my $args = { ref $_[0] eq 'HASH' ? %{$_[0]} : @_ };
406
407 unless ( defined $args->{msg} and length $args->{msg} ) {
408 emit_loud_diag(
409 msg => "No 'msg' value supplied to emit_loud_diag()"
410 );
411 exit 70;
412 }
413
73f54e27 414 my $msg = "\n" . join( ': ',
415 ( $0 eq '-e' ? () : $0 ),
416 $args->{msg}
417 );
c40b5744 418
419 # when we die - we usually want to keep doing it
420 $args->{emit_dups} = !!$args->{confess}
421 unless exists $args->{emit_dups};
422
423 local $Carp::CarpLevel =
424 ( $args->{skip_frames} || 0 )
425 +
426 $Carp::CarpLevel
427 +
428 # hide our own frame
429 1
430 ;
431
432 my $longmess = Carp::longmess();
433
434 # different object references will thwart deduplication without this
435 ( my $key = "${msg}\n${longmess}" ) =~ s/\b0x[0-9a-f]+\b/0x.../gi;
436
437 return $seen_loud_screams->{$key} if
438 $seen_loud_screams->{$key}++
439 and
440 ! $args->{emit_dups}
441 ;
442
443 $msg .= $longmess
444 unless $msg =~ /\n\z/;
445
446 print STDERR "$msg\n"
447 or
448 print STDOUT "\n!!!STDERR ISN'T WRITABLE!!!:$msg\n";
449
450 return $seen_loud_screams->{$key}
451 unless $args->{confess};
452
453 # increment *again*, because... Carp.
454 $Carp::CarpLevel++;
455
456 # not $msg - Carp will reapply the longmess on its own
457 Carp::confess($args->{msg});
458}
459
460
293cb2f1 461###
462### This is *NOT* boolean.pm - deliberately not using a singleton
463###
464{
465 package # hide from pause
466 DBIx::Class::_Util::_Bool;
467 use overload
468 bool => sub { ${$_[0]} },
469 fallback => 1,
470 ;
471}
472sub true () { my $x = 1; bless \$x, "DBIx::Class::_Util::_Bool" }
473sub false () { my $x = 0; bless \$x, "DBIx::Class::_Util::_Bool" }
474
bbf6a9a5 475sub scope_guard (&) {
476 croak 'Calling scope_guard() in void context makes no sense'
477 if ! defined wantarray;
478
479 # no direct blessing of coderefs - DESTROY is buggy on those
480 bless [ $_[0] ], 'DBIx::Class::_Util::ScopeGuard';
481}
482{
483 package #
484 DBIx::Class::_Util::ScopeGuard;
485
486 sub DESTROY {
487 &DBIx::Class::_Util::detected_reinvoked_destructor;
488
489 local $@ if DBIx::Class::_ENV_::UNSTABLE_DOLLARAT;
490
491 eval {
492 $_[0]->[0]->();
493 1;
118b2c36 494 }
495 or
c40b5744 496 DBIx::Class::_Util::emit_loud_diag(
497 emit_dups => 1,
498 msg => "Execution of scope guard $_[0] resulted in the non-trappable exception:\n\n$@\n "
118b2c36 499 );
bbf6a9a5 500 }
501}
502
503
841efcb3 504sub is_exception ($) {
505 my $e = $_[0];
506
35cf7d1a 507 # FIXME
a0414138 508 # this is not strictly correct - an eval setting $@ to undef
509 # is *not* the same as an eval setting $@ to ''
510 # but for the sake of simplicity assume the following for
511 # the time being
512 return 0 unless defined $e;
513
841efcb3 514 my ($not_blank, $suberror);
515 {
5c33c8be 516 local $SIG{__DIE__} if $SIG{__DIE__};
841efcb3 517 local $@;
518 eval {
d52c4a75 519 # The ne() here is deliberate - a plain length($e), or worse "$e" ne
520 # will entirely obviate the need for the encolsing eval{}, as the
521 # condition we guard against is a missing fallback overload
522 $not_blank = ( $e ne '' );
841efcb3 523 1;
524 } or $suberror = $@;
525 }
526
527 if (defined $suberror) {
528 if (length (my $class = blessed($e) )) {
529 carp_unique( sprintf(
9bea2000 530 'External exception class %s implements partial (broken) overloading '
531 . 'preventing its instances from being used in simple ($x eq $y) '
841efcb3 532 . 'comparisons. Given Perl\'s "globally cooperative" exception '
533 . 'handling this type of brokenness is extremely dangerous on '
534 . 'exception objects, as it may (and often does) result in silent '
535 . '"exception substitution". DBIx::Class tries to work around this '
536 . 'as much as possible, but other parts of your software stack may '
537 . 'not be even aware of this. Please submit a bugreport against the '
538 . 'distribution containing %s and in the meantime apply a fix similar '
539 . 'to the one shown at %s, in order to ensure your exception handling '
540 . 'is saner application-wide. What follows is the actual error text '
541 . "as generated by Perl itself:\n\n%s\n ",
9bea2000 542 $class,
841efcb3 543 $class,
544 'http://v.gd/DBIC_overload_tempfix/',
545 $suberror,
546 ));
547
548 # workaround, keeps spice flowing
d52c4a75 549 $not_blank = !!( length $e );
841efcb3 550 }
551 else {
552 # not blessed yet failed the 'ne'... this makes 0 sense...
553 # just throw further
554 die $suberror
555 }
556 }
84e4e006 557 elsif (
558 # a ref evaluating to '' is definitively a "null object"
559 ( not $not_blank )
560 and
561 length( my $class = ref $e )
562 ) {
c40b5744 563 carp_unique(
564 "Objects of external exception class '$class' stringify to '' (the "
84e4e006 565 . 'empty string), implementing the so called null-object-pattern. '
566 . 'Given Perl\'s "globally cooperative" exception handling using this '
567 . 'class of exceptions is extremely dangerous, as it may (and often '
568 . 'does) result in silent discarding of errors. DBIx::Class tries to '
569 . 'work around this as much as possible, but other parts of your '
570 . 'software stack may not be even aware of the problem. Please submit '
c40b5744 571 . "a bugreport against the distribution containing '$class'",
572 );
84e4e006 573
574 $not_blank = 1;
575 }
841efcb3 576
577 return $not_blank;
578}
579
3d56e026 580{
ddcc02d1 581 my $callstack_state;
582
583 # Recreate the logic of try(), while reusing the catch()/finally() as-is
584 #
585 # FIXME: We need to move away from Try::Tiny entirely (way too heavy and
586 # yes, shows up ON TOP of profiles) but this is a batle for another maint
587 sub dbic_internal_try (&;@) {
588
589 my $try_cref = shift;
590 my $catch_cref = undef; # apparently this is a thing... https://rt.perl.org/Public/Bug/Display.html?id=119311
591
592 for my $arg (@_) {
593
594 if( ref($arg) eq 'Try::Tiny::Catch' ) {
595
596 croak 'dbic_internal_try() may not be followed by multiple catch() blocks'
597 if $catch_cref;
598
599 $catch_cref = $$arg;
600 }
601 elsif ( ref($arg) eq 'Try::Tiny::Finally' ) {
602 croak 'dbic_internal_try() does not support finally{}';
603 }
604 else {
605 croak(
606 'dbic_internal_try() encountered an unexpected argument '
607 . "'@{[ defined $arg ? $arg : 'UNDEF' ]}' - perhaps "
608 . 'a missing semi-colon before or ' # trailing space important
609 );
610 }
611 }
612
613 my $wantarray = wantarray;
614 my $preexisting_exception = $@;
615
616 my @ret;
617 my $all_good = eval {
618 $@ = $preexisting_exception;
619
620 local $callstack_state->{in_internal_try} = 1
621 unless $callstack_state->{in_internal_try};
622
623 # always unset - someone may have snuck it in
5c33c8be 624 local $SIG{__DIE__} if $SIG{__DIE__};
ddcc02d1 625
626 if( $wantarray ) {
627 @ret = $try_cref->();
628 }
629 elsif( defined $wantarray ) {
630 $ret[0] = $try_cref->();
631 }
632 else {
633 $try_cref->();
634 }
635
636 1;
637 };
638
639 my $exception = $@;
640 $@ = $preexisting_exception;
641
642 if ( $all_good ) {
643 return $wantarray ? @ret : $ret[0]
644 }
645 elsif ( $catch_cref ) {
646 for ( $exception ) {
647 return $catch_cref->($exception);
648 }
649 }
650
651 return;
652 }
653
654 sub in_internal_try { !! $callstack_state->{in_internal_try} }
655}
656
657{
3d56e026 658 my $destruction_registry = {};
659
04c1a070 660 sub DBIx::Class::__Util_iThreads_handler__::CLONE {
d098704f 661 %$destruction_registry = map {
662 (defined $_)
663 ? ( refaddr($_) => $_ )
664 : ()
665 } values %$destruction_registry;
d52fc26d 666
d098704f 667 weaken($_) for values %$destruction_registry;
29211e03 668
d52fc26d 669 # Dummy NEXTSTATE ensuring the all temporaries on the stack are garbage
670 # collected before leaving this scope. Depending on the code above, this
671 # may very well be just a preventive measure guarding future modifications
672 undef;
3d56e026 673 }
674
675 # This is almost invariably invoked from within DESTROY
676 # throwing exceptions won't work
e1d9e578 677 sub detected_reinvoked_destructor {
3d56e026 678
679 # quick "garbage collection" pass - prevents the registry
680 # from slowly growing with a bunch of undef-valued keys
681 defined $destruction_registry->{$_} or delete $destruction_registry->{$_}
682 for keys %$destruction_registry;
683
e1d9e578 684 if (! length ref $_[0]) {
c40b5744 685 emit_loud_diag(
686 emit_dups => 1,
687 msg => (caller(0))[3] . '() expects a blessed reference'
688 );
3d56e026 689 return undef; # don't know wtf to do
690 }
e1d9e578 691 elsif (! defined $destruction_registry->{ my $addr = refaddr($_[0]) } ) {
3d56e026 692 weaken( $destruction_registry->{$addr} = $_[0] );
693 return 0;
694 }
695 else {
c40b5744 696 emit_loud_diag( msg => sprintf (
3d56e026 697 'Preventing *MULTIPLE* DESTROY() invocations on %s - an *EXTREMELY '
698 . 'DANGEROUS* condition which is *ALMOST CERTAINLY GLOBAL* within your '
699 . 'application, affecting *ALL* classes without active protection against '
700 . 'this. Diagnose and fix the root cause ASAP!!!%s',
701 refdesc $_[0],
702 ( ( $INC{'Devel/StackTrace.pm'} and ! do { local $@; eval { Devel::StackTrace->VERSION(2) } } )
703 ? " (likely culprit Devel::StackTrace\@@{[ Devel::StackTrace->VERSION ]} found in %INC, http://is.gd/D_ST_refcap)"
704 : ''
705 )
706 ));
707
708 return 1;
709 }
710 }
711}
712
7302b3e0 713my $module_name_rx = qr/ \A [A-Z_a-z] [0-9A-Z_a-z]* (?: :: [0-9A-Z_a-z]+ )* \z /x;
714my $ver_rx = qr/ \A [0-9]+ (?: \. [0-9]+ )* (?: \_ [0-9]+ )* \z /x;
715
bf302897 716sub modver_gt_or_eq ($$) {
b1dbf716 717 my ($mod, $ver) = @_;
718
719 croak "Nonsensical module name supplied"
7302b3e0 720 if ! defined $mod or $mod !~ $module_name_rx;
b1dbf716 721
722 croak "Nonsensical minimum version supplied"
7302b3e0 723 if ! defined $ver or $ver !~ $ver_rx;
724
725 no strict 'refs';
726 my $ver_cache = ${"${mod}::__DBIC_MODULE_VERSION_CHECKS__"} ||= ( $mod->VERSION
727 ? {}
728 : croak "$mod does not seem to provide a version (perhaps it never loaded)"
729 );
730
731 ! defined $ver_cache->{$ver}
732 and
733 $ver_cache->{$ver} = do {
b1dbf716 734
7302b3e0 735 local $SIG{__WARN__} = sigwarn_silencer( qr/\Qisn't numeric in subroutine entry/ )
736 if SPURIOUS_VERSION_CHECK_WARNINGS;
b1dbf716 737
5c33c8be 738 local $SIG{__DIE__} if $SIG{__DIE__};
7302b3e0 739 local $@;
7302b3e0 740 eval { $mod->VERSION($ver) } ? 1 : 0;
741 };
56270bba 742
7302b3e0 743 $ver_cache->{$ver};
b1dbf716 744}
745
d634850b 746sub modver_gt_or_eq_and_lt ($$$) {
747 my ($mod, $v_ge, $v_lt) = @_;
748
749 croak "Nonsensical maximum version supplied"
7302b3e0 750 if ! defined $v_lt or $v_lt !~ $ver_rx;
d634850b 751
752 return (
753 modver_gt_or_eq($mod, $v_ge)
754 and
755 ! modver_gt_or_eq($mod, $v_lt)
756 ) ? 1 : 0;
757}
758
296248c3 759{
296248c3 760
761 sub describe_class_methods {
8eac247d 762 my $args = (
763 ref $_[0] eq 'HASH' ? $_[0]
764 : ( @_ == 1 and ! length ref $_[0] ) ? { class => $_[0] }
765 : { @_ }
766 );
767
768 my ($class, $requested_mro) = @{$args}{qw( class use_mro )};
296248c3 769
8eac247d 770 croak "Expecting a class name either as the sole argument or a 'class' option"
5e67be26 771 if not defined $class or $class !~ $module_name_rx;
296248c3 772
5f0174dc 773 croak(
774 "The supplied 'class' argument is tainted: this is *extremely* "
775 . 'dangerous, fix your code ASAP!!! ( for more details read through '
776 . 'https://is.gd/perl_mro_taint_wtf )'
777 ) if (
778 DBIx::Class::_ENV_::TAINT_MODE
779 and
780 Scalar::Util::tainted($class)
781 );
782
1cf2ad8b 783 $requested_mro ||= mro::get_mro($class);
784
785 # mro::set_mro() does not bump pkg_gen - WHAT THE FUCK?!
786 my $query_cache_key = "$class|$requested_mro";
787
953f8eb0 788 my $internal_cache_key =
1cf2ad8b 789 ( mro::get_mro($class) eq $requested_mro )
790 ? $class
791 : $query_cache_key
792 ;
793
296248c3 794 # use a cache on old MRO, since while we are recursing in this function
795 # nothing can possibly change (the speedup is immense)
796 # (yes, people could be tie()ing the stash and adding methods on access
797 # but there is a limit to how much crazy can be supported here)
798 #
799 # we use the cache for linear_isa lookups on new MRO as well - it adds
800 # a *tiny* speedup, and simplifies the code a lot
801 #
953f8eb0 802 local $__describe_class_query_cache->{'!internal!'} = {}
803 unless $__describe_class_query_cache->{'!internal!'};
296248c3 804
805 my $my_gen = 0;
806
d01688cc 807 $my_gen += get_real_pkg_gen($_) for ( my @full_ISA = (
808
809 @{
953f8eb0 810 $__describe_class_query_cache->{'!internal!'}{$internal_cache_key}{linear_isa}
296248c3 811 ||=
1cf2ad8b 812 mro::get_linear_isa($class, $requested_mro)
d01688cc 813 },
814
815 ((
953f8eb0 816 $__describe_class_query_cache->{'!internal!'}{$class}{is_universal}
d01688cc 817 ||=
818 mro::is_universal($class)
819 ) ? () : @{
953f8eb0 820 $__describe_class_query_cache->{'!internal!'}{UNIVERSAL}{linear_isa}
d01688cc 821 ||=
822 mro::get_linear_isa("UNIVERSAL")
823 }),
824
825 ));
296248c3 826
953f8eb0 827 my $slot = $__describe_class_query_cache->{$query_cache_key} ||= {};
296248c3 828
829 unless ( ($slot->{cumulative_gen}||0) == $my_gen ) {
830
831 # reset
832 %$slot = (
833 class => $class,
2603b495 834 isa => { map { $_ => 1 } @full_ISA },
835 linear_isa => [
953f8eb0 836 @{ $__describe_class_query_cache->{'!internal!'}{$internal_cache_key}{linear_isa} }
837 [ 1 .. $#{$__describe_class_query_cache->{'!internal!'}{$internal_cache_key}{linear_isa}} ]
d01688cc 838 ],
296248c3 839 mro => {
1cf2ad8b 840 type => $requested_mro,
841 is_c3 => ( ($requested_mro eq 'c3') ? 1 : 0 ),
296248c3 842 },
843 cumulative_gen => $my_gen,
844 );
296248c3 845
2603b495 846 # remove ourselves from ISA
847 shift @full_ISA;
848
296248c3 849 # ensure the cache is populated for the parents, code below can then
850 # efficiently operate over the query_cache directly
d01688cc 851 describe_class_methods($_) for reverse @full_ISA;
296248c3 852
296248c3 853 no strict 'refs';
854
855 # combine full ISA-order inherited and local method list into a
856 # "shadowing stack"
857
858 (
085dbdd6 859 unshift @{ $slot->{methods}{$_->{name}} }, $_
296248c3 860
861 and
862
085dbdd6 863 (
864 $_->{via_class} ne $class
865 or
866 $slot->{methods_defined_in_class}{$_->{name}} = $_
867 )
296248c3 868
869 and
870
871 @{ $slot->{methods}{$_->{name}} } > 1
872
873 and
874
875 $slot->{methods_with_supers}{$_->{name}} = $slot->{methods}{$_->{name}}
876
877 ) for (
878
d01688cc 879 # what describe_class_methods for @full_ISA produced above
085dbdd6 880 ( map { values %{
953f8eb0 881 $__describe_class_query_cache->{$_}{methods_defined_in_class} || {}
1cf2ad8b 882 } } map { "$_|" . mro::get_mro($_) } reverse @full_ISA ),
296248c3 883
884 # our own non-cleaned subs + their attributes
885 ( map {
886 (
1c179556 887 # need to account for dummy helper crefs under OLD_MRO
296248c3 888 (
1c179556 889 ! DBIx::Class::_ENV_::OLD_MRO
296248c3 890 or
1c179556 891 ! ( ( $Class::C3::MRO{$class} || {} )->{methods}{$_} )
296248c3 892 )
893 and
1c179556 894 # these 2 OR-ed checks are sufficient for 5.10+
296248c3 895 (
1c179556 896 ref(\ "${class}::"->{$_} ) ne 'GLOB'
296248c3 897 or
1c179556 898 defined( *{ "${class}::"->{$_} }{CODE} )
296248c3 899 )
900 ) ? {
901 via_class => $class,
902 name => $_,
92705f7f 903 attributes => { map { $_ => 1 } do {
904 my @attrs;
905 local $@;
906 local $SIG{__DIE__} if $SIG{__DIE__};
907 # attributes::get may throw on blessed-false crefs :/
908 eval { @attrs = attributes::get( \&{"${class}::${_}"} ); 1 }
909 or warn "Unable to determine attributes of the \\&${class}::$_ method due to following error: $@";
910 @attrs;
911 } },
296248c3 912 }
913 : ()
914 } keys %{"${class}::"} )
915 );
916
917
918 # recalculate the pkg_gen on newer perls under Taint mode,
919 # because of shit like:
920 # perl -T -Mmro -e 'package Foo; sub bar {}; defined( *{ "Foo::"->{bar}}{CODE} ) and warn mro::get_pkg_gen("Foo") for (1,2,3)'
921 #
922 if (
923 ! DBIx::Class::_ENV_::OLD_MRO
924 and
5f0174dc 925 DBIx::Class::_ENV_::TAINT_MODE
296248c3 926 ) {
927
928 $slot->{cumulative_gen} = 0;
929 $slot->{cumulative_gen} += get_real_pkg_gen($_)
d01688cc 930 for $class, @full_ISA;
296248c3 931 }
932 }
933
934 # RV
935 +{ %$slot };
936 }
937}
938
e3be2b6f 939
940#
941# Why not just use some higher-level module or at least File::Spec here?
942# Because:
943# 1) This is a *very* rarely used function, and the deptree is large
944# enough already as it is
945#
946# 2) (more importantly) Our tooling is utter shit in this area. There
947# is no comprehensive support for UNC paths in PathTools and there
948# are also various small bugs in representation across different
949# path-manipulation CPAN offerings.
950#
951# Since this routine is strictly used for logical path processing (it
952# *must* be able to work with not-yet-existing paths), use this seemingly
953# simple but I *think* complete implementation to feed to other consumers
954#
955# If bugs are ever uncovered in this routine, *YOU ARE URGED TO RESIST*
956# the impulse to bring in an external dependency. During runtime there
957# is exactly one spot that could potentially maybe once in a blue moon
958# use this function. Keep it lean.
959#
960sub parent_dir ($) {
961 ( $_[0] =~ m{ [\/\\] ( \.{0,2} ) ( [\/\\]* ) \z }x )
962 ? (
963 $_[0]
964 .
965 ( ( length($1) and ! length($2) ) ? '/' : '' )
966 .
967 '../'
968 )
969 : (
970 require File::Spec
971 and
972 File::Spec->catpath (
973 ( File::Spec->splitpath( "$_[0]" ) )[0,1],
974 '/',
975 )
976 )
977 ;
978}
979
439a7283 980sub mkdir_p ($) {
981 require File::Path;
982 # do not ask for a recent version, use 1.x API calls
983 File::Path::mkpath([ "$_[0]" ]); # File::Path does not like objects
984}
985
e3be2b6f 986
a9da9b6a 987{
988 my $list_ctx_ok_stack_marker;
989
e89c7968 990 sub fail_on_internal_wantarray () {
a9da9b6a 991 return if $list_ctx_ok_stack_marker;
992
993 if (! defined wantarray) {
994 croak('fail_on_internal_wantarray() needs a tempvar to save the stack marker guard');
995 }
996
997 my $cf = 1;
821edc09 998 while ( ( (CORE::caller($cf+1))[3] || '' ) =~ / :: (?:
a9da9b6a 999
1000 # these are public API parts that alter behavior on wantarray
1001 search | search_related | slice | search_literal
1002
1003 |
1004
1005 # these are explicitly prefixed, since we only recognize them as valid
1006 # escapes when they come from the guts of CDBICompat
1007 CDBICompat .*? :: (?: search_where | retrieve_from_sql | retrieve_all )
1008
1009 ) $/x ) {
1010 $cf++;
1011 }
1012
e89c7968 1013 my ($fr, $want, $argdesc);
1014 {
1015 package DB;
821edc09 1016 $fr = [ CORE::caller($cf) ];
1017 $want = ( CORE::caller($cf-1) )[5];
e89c7968 1018 $argdesc = ref $DB::args[0]
1019 ? DBIx::Class::_Util::refdesc($DB::args[0])
1020 : 'non '
1021 ;
1022 };
1023
a9da9b6a 1024 if (
e89c7968 1025 $want and $fr->[0] =~ /^(?:DBIx::Class|DBICx::)/
a9da9b6a 1026 ) {
a9da9b6a 1027 DBIx::Class::Exception->throw( sprintf (
e89c7968 1028 "Improper use of %s instance in list context at %s line %d\n\n Stacktrace starts",
1029 $argdesc, @{$fr}[1,2]
a9da9b6a 1030 ), 'with_stacktrace');
1031 }
1032
d098704f 1033 weaken( $list_ctx_ok_stack_marker = my $mark = [] );
1034
a9da9b6a 1035 $mark;
1036 }
1037}
1038
77c3a5dc 1039sub fail_on_internal_call {
1040 my ($fr, $argdesc);
1041 {
1042 package DB;
821edc09 1043 $fr = [ CORE::caller(1) ];
e570488a 1044 $argdesc =
1045 ( not defined $DB::args[0] ) ? 'UNAVAILABLE'
1046 : ( length ref $DB::args[0] ) ? DBIx::Class::_Util::refdesc($DB::args[0])
1047 : $DB::args[0] . ''
77c3a5dc 1048 ;
1049 };
1050
3b020224 1051 my @fr2;
1052 # need to make allowance for a proxy-yet-direct call
1053 my $check_fr = (
1054 $fr->[0] eq 'DBIx::Class::ResultSourceProxy'
1055 and
1056 @fr2 = (CORE::caller(2))
1057 and
1058 (
1059 ( $fr->[3] =~ /([^:])+$/ )[0]
1060 eq
1061 ( $fr2[3] =~ /([^:])+$/ )[0]
1062 )
1063 )
1064 ? \@fr2
1065 : $fr
1066 ;
1067
1b822bd3 1068
1069 die "\nMethod $fr->[3] is not marked with the 'DBIC_method_is_indirect_sugar' attribute\n\n" unless (
1070
1071 # unlikely but who knows...
1072 ! @$fr
1073
1074 or
1075
1076 # This is a weird-ass double-purpose method, only one branch of which is marked
1077 # as an illegal indirect call
1078 # Hence the 'indirect' attribute makes no sense
1079 # FIXME - likely need to mark this in some other manner
1080 $fr->[3] eq 'DBIx::Class::ResultSet::new'
1081
1082 or
1083
1084 # RsrcProxy stuff is special and not attr-annotated on purpose
1085 # Yet it is marked (correctly) as fail_on_internal_call(), as DBIC
1086 # itself should not call these methods as first-entry
1087 $fr->[3] =~ /^DBIx::Class::ResultSourceProxy::[^:]+$/
1088
1089 or
1090
1091 # FIXME - there is likely a more fine-graned way to escape "foreign"
1092 # callers, based on annotations... (albeit a slower one)
1093 # For the time being just skip in a dumb way
1094 $fr->[3] !~ /^DBIx::Class|^DBICx::|^DBICTest::/
1095
1096 or
1097
1098 grep
1099 { $_ eq 'DBIC_method_is_indirect_sugar' }
1100 do { no strict 'refs'; attributes::get( \&{ $fr->[3] }) }
1101 );
1102
1103
77c3a5dc 1104 if (
e570488a 1105 defined $fr->[0]
77c3a5dc 1106 and
3b020224 1107 $check_fr->[0] =~ /^(?:DBIx::Class|DBICx::)/
77c3a5dc 1108 and
3b020224 1109 $check_fr->[1] !~ /\b(?:CDBICompat|ResultSetProxy)\b/ # no point touching there
77c3a5dc 1110 ) {
1111 DBIx::Class::Exception->throw( sprintf (
e5053694 1112 "Illegal internal call of indirect proxy-method %s() with argument '%s': examine the last lines of the proxy method deparse below to determine what to call directly instead at %s on line %d\n\n%s\n\n Stacktrace starts",
77c3a5dc 1113 $fr->[3], $argdesc, @{$fr}[1,2], ( $fr->[6] || do {
1114 require B::Deparse;
1115 no strict 'refs';
1116 B::Deparse->new->coderef2text(\&{$fr->[3]})
1117 }),
1118 ), 'with_stacktrace');
1119 }
1120}
1121
534aff61 1122if (DBIx::Class::_ENV_::ASSERT_NO_ERRONEOUS_METAINSTANCE_USE) {
1123
1124 no warnings 'redefine';
1125
1126 my $next_bless = defined(&CORE::GLOBAL::bless)
1127 ? \&CORE::GLOBAL::bless
1128 : sub { CORE::bless($_[0], $_[1]) }
1129 ;
1130
1131 *CORE::GLOBAL::bless = sub {
1132 my $class = (@_ > 1) ? $_[1] : CORE::caller();
1133
1134 # allow for reblessing (role application)
1135 return $next_bless->( $_[0], $class )
1136 if defined blessed $_[0];
1137
1138 my $obj = $next_bless->( $_[0], $class );
1139
1140 my $calling_sub = (CORE::caller(1))[3] || '';
1141
1142 (
1143 # before 5.18 ->isa() will choke on the "0" package
1144 # which we test for in several obscure cases, sigh...
1145 !( DBIx::Class::_ENV_::PERL_VERSION < 5.018 )
1146 or
1147 $class
1148 )
1149 and
1150 (
1151 (
1152 $calling_sub !~ /^ (?:
1153 DBIx::Class::Schema::clone
1154 |
1155 DBIx::Class::DB::setup_schema_instance
1156 )/x
1157 and
1158 $class->isa("DBIx::Class::Schema")
1159 )
1160 or
1161 (
1162 $calling_sub ne 'DBIx::Class::ResultSource::new'
1163 and
1164 $class->isa("DBIx::Class::ResultSource")
1165 )
1166 )
1167 and
1168 local $Carp::CarpLevel = $Carp::CarpLevel + 1
1169 and
1170 Carp::confess("Improper instantiation of '$obj': you *MUST* call the corresponding constructor");
1171
1172
1173 $obj;
1174 };
1175}
1176
b1dbf716 11771;